/********************************** (C) COPYRIGHT *******************************
* File Name          : Main.c
* Author             : WCH
* Version            : V1.0
* Date               : 2018/12/15
* Description        : ԶUSB豸CH372豸ṩ80ͨ(ϴ+´)ʵ´Ȼȡϴ
*******************************************************************************/
#include "CH57x_common.h"
#include "usr_cfg.h"
#include "HID_CDC.h"

UINT8 Endp1Busy = 0;
UINT8 Endp3Busy = 0;
UINT8 Endp4Busy = 0;
UINT8   SetupReq, SetupLen, UsbConfigRdy, UsbConfig;
const UINT8* pDescr;    //USBñ־        
UINT8 CDC_RecBuf[64];

/*豸*/
const UINT8 DevDesc[18] = {
  0x12, 0x01, 0x10, 0x01, 0xEF, 0x02, 0x01, THIS_ENDP0_SIZE,
  0x86, 0x1a, 0x22, 0x57, 0x00, 0x00, 0x01, 0x02,
  0x03, 0x01
};

/**/
const UINT8 CfgDesc[] = {
  0x09, 0x02, 0x73, 0x00, 0x03, 0x01, 0x00, 0xA0, 0x32, //

  /*HID豸*/
  0x08, 0x0b, 0x00, 0x01, 0x03, 0x00, 0x00, 0x05,

  0x09, 0x04, 0x00, 0x00, 0x02, 0x03, 0x00, 0x00, 0x05, //ӿ
  0x09, 0x21, 0x00, 0x01, 0x00, 0x01, 0x22, 0x22, 0x00, //HID
  0x07, 0x05, 0x81, 0x03, THIS_ENDP0_SIZE, 0x00, 0x01, //˵
  0x07, 0x05, 0x01, 0x03, THIS_ENDP0_SIZE, 0x00, 0x01, //˵

  /*CDC豸*/
  /* Interface Association Descriptor(IAD Descriptor)  */
  0x08, 0x0b, 0x01, 0x02, 0x02, 0x02, 0x01, 0x00,

  0x09, 0x04, 0x01, 0x00, 0x01, 0x02, 0x02, 0x01, 0x00,     //CDCӿ(һ˵)
  //Ϊ
  0x05, 0x24, 0x00, 0x10, 0x01,                             //(ͷ)
  0x05, 0x24, 0x01, 0x00, 0x00,                             //(ûӿ) 03 01
  0x04, 0x24, 0x02, 0x02,                                   //֧Set_Line_CodingSet_Control_Line_StateGet_Line_CodingSerial_State
  0x05, 0x24, 0x06, 0x00, 0x01,                             //Ϊ0CDCӿ;1ӿ
  0x07, 0x05, 0x82, 0x03, 0x08, 0x00, 0xFF,                 //жϴ˵
  //Ϊӿ1ݽӿڣ
  0x09, 0x04, 0x02, 0x00, 0x02, 0x0a, 0x00, 0x00, 0x00,     //ݽӿ
  0x07, 0x05, 0x03, 0x02, THIS_ENDP0_SIZE, 0x00, 0x00,      //˵
  0x07, 0x05, 0x83, 0x02, THIS_ENDP0_SIZE, 0x00, 0x00,      //˵
};

/*HIḎ*/
const UINT8 KeyRepDesc[62] = {
  0x05, 0x01, 0x09, 0x06, 0xA1, 0x01, 0x05, 0x07,
  0x19, 0xe0, 0x29, 0xe7, 0x15, 0x00, 0x25, 0x01,
  0x75, 0x01, 0x95, 0x08, 0x81, 0x02, 0x95, 0x01,
  0x75, 0x08, 0x81, 0x01, 0x95, 0x03, 0x75, 0x01,
  0x05, 0x08, 0x19, 0x01, 0x29, 0x03, 0x91, 0x02,
  0x95, 0x05, 0x75, 0x01, 0x91, 0x01, 0x95, 0x06,
  0x75, 0x08, 0x26, 0xff, 0x00, 0x05, 0x07, 0x19,
  0x00, 0x29, 0x91, 0x81, 0x00, 0xC0
};

/**/
UINT8 HIDKey[8] = {0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0};

/*HID౨*/
const UINT8 HIDRepDesc[ ] = {
  0x06, 0x00, 0xff, 0x09, 0x01, 0xa1, 0x01, 0x09,
  0x02, 0x15, 0x00, 0x26, 0x00, 0xff, 0x75, 0x08,
  0x95, THIS_ENDP0_SIZE, 0x81, 0x06, 0x09, 0x02, 0x15, 0x00,
  0x26, 0x00, 0xff, 0x75, 0x08, 0x95, THIS_ENDP0_SIZE, 0x91,
  0x06, 0xC0
};

//cdc
UINT8 LineCoding[7] = {0x00, 0xe1, 0x00, 0x00, 0x00, 0x00, 0x08}; //ʼΪ576001ֹͣλУ飬8λ

/*CDCַ*/
const UINT8 LangDes[] = {0x04, 0x03, 0x09, 0x04};      //
const UINT8 SerDes[] = {                               //кַ
  0x14, 0x03,
  0x32, 0x00, 0x30, 0x00, 0x31, 0x00, 0x37, 0x00, 0x2D, 0x00,
  0x32, 0x00, 0x2D, 0x00,
  0x32, 0x00, 0x35, 0x00
};
const UINT8 Prod_Des[] = {                              //Ʒַ
  0x14, 0x03,
  0x43, 0x00, 0x48, 0x00, 0x35, 0x00, 0x35, 0x00, 0x34, 0x00, 0x5F, 0x00,
  0x43, 0x00, 0x44, 0x00, 0x43, 0x00,
};
const UINT8 Manuf_Des[] = {
  0x0A, 0x03,
  0x5F, 0x6c, 0xCF, 0x82, 0x81, 0x6c, 0x52, 0x60,
};
#define  SET_LINE_CODING                0X20            // Configures DTE rate, stop-bits, parity, and number-of-character
#define  GET_LINE_CODING                0X21            // This request allows the host to find out the currently configured line coding.
#define  SET_CONTROL_LINE_STATE         0X22            // This request generates RS-232/V.24 style control signals.

/*******************************************************************************
* Function Name  : Enp4IntIn()
* Description    : USB豸ģʽ˵1жϴ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void Enp4IntIn(UINT8* Buf, UINT8 Length)
{
  memcpy(&pEP0_RAM_Addr[64], Buf, Length); //ϴ
  R8_UEP4_T_LEN = Length;     //ϴݳ
  R8_UEP4_CTRL = R8_UEP4_CTRL & ~ MASK_UEP_T_RES | UEP_T_RES_ACK;   //ʱϴݲӦACK
}
/*******************************************************************************
* Function Name  : DeviceInterrupt()
* Description    : CH552USBжϴ
*******************************************************************************/
void  USB_DevTransProcess(void)         //USBжϷ,ʹüĴ1
{
  UINT8 i = 0;
  UINT8  len, chtype;
  UINT8  intflag, errflag = 0;
  intflag = R8_USB_INT_FG;
    if (intflag & RB_UIF_TRANSFER) { //tranfer success    //USBɱ־
    switch (R8_USB_INT_ST & (MASK_UIS_TOKEN | MASK_UIS_ENDP)) {
      case UIS_TOKEN_IN | 1:                                                  //endpoint 1# ж϶˵ϴ   HID豸 IN
        R8_UEP1_T_LEN = 0;                                                     //Ԥʹ÷ͳһҪ
        Endp1Busy = 0;
        R8_UEP1_CTRL = R8_UEP1_CTRL & ~ MASK_UEP_T_RES | UEP_T_RES_NAK;           //ĬӦNAK
        break;

      case UIS_TOKEN_OUT | 1:                                                 //endpoint 1# ˵´   HID豸 OUT
        if (RB_U_TOG_OK) {                                                     // ͬݰ
          len = R8_USB_RX_LEN;                                               //ݳȣݴEp2Buffer׵ַʼ
          //ݣΪlen;
        }
        break;

      case UIS_TOKEN_IN | 2:                                                  //endpoint 2# ˵жϴ
        R8_UEP2_T_LEN = 0;
        R8_UEP2_CTRL = R8_UEP2_CTRL & ~ MASK_UEP_T_RES | UEP_T_RES_NAK;           //ĬӦNAK
        break;
      case UIS_TOKEN_IN | 3: {                                                //endpoint 3# ˵ϴ  CDC IN
        R8_UEP3_T_LEN = 0;                                                    //Ԥʹ÷ͳһҪ
        R8_UEP3_CTRL = R8_UEP3_CTRL & ~ MASK_UEP_T_RES | UEP_T_RES_NAK;           //ĬӦNAK
        Endp3Busy = 0;                                                  //æ־
      }
      break;
      case UIS_TOKEN_OUT | 3:                                                 //endpoint 3# ˵´  CDC OUT
        if (RB_U_TOG_OK) {                                                     // ͬݰ
          len = R8_USB_RX_LEN;
          for (i = 0; i < len; i ++) {
            pEP3_RAM_Addr[64 + i] = pEP3_RAM_Addr[i];  // OUT͸INɼ֤
            //printf("0x%x\r\n",pEP3_RAM_Addr[i]);
          }
          R8_UEP3_T_LEN = len;
          R8_UEP3_CTRL = R8_UEP3_CTRL & ~ MASK_UEP_T_RES | UEP_T_RES_ACK;// ϴ
        }
        break;

      case UIS_TOKEN_IN | 4:                                                  //endpoint 4# ж϶˵ϴ    IN
        R8_UEP4_T_LEN = 0;                                                     //Ԥʹ÷ͳһҪ
        R8_UEP4_CTRL ^= RB_UEP_T_TOG;                                          //ԶתҪֶת
        Endp4Busy = 0 ;
        R8_UEP4_CTRL = R8_UEP4_CTRL & ~ MASK_UEP_T_RES | UEP_T_RES_NAK;           //ĬӦNAK
        break;

      case UIS_TOKEN_SETUP | 0:                                                //SETUP
        len = R8_USB_RX_LEN;
        if (len == (sizeof(USB_SETUP_REQ))) {
          SetupLen = (pSetupReqPak->wLength)&0XFF;
          if ((pSetupReqPak->wLength >> 8) || SetupLen > 0xFF) {
            SetupLen = 0xFF;    // ܳ
          }
          len = 0;                                                        // ĬΪɹϴ0
          SetupReq = pSetupReqPak->bRequest;
          if ((pSetupReqPak->bRequestType & USB_REQ_TYP_MASK) != USB_REQ_TYP_STANDARD) {  /* HID */
            switch (SetupReq) {
              case 0x01://GetReport
                break;
              case 0x02://GetIdle
                break;
              case 0x03://GetProtocol
                break;
              case 0x09://SetReport
                break;
              case 0x0A://SetIdle
                break;
              case 0x0B://SetProtocol
                break;
              case GET_LINE_CODING:   //0x21  currently configured
                pDescr = LineCoding;
                len = sizeof(LineCoding);
                len = SetupLen >= DEFAULT_ENDP0_SIZE ? DEFAULT_ENDP0_SIZE : SetupLen;  // δ䳤
                memcpy(pEP0_DataBuf, pDescr, len);
                SetupLen -= len;
                pDescr += len;
                break;
              case SET_CONTROL_LINE_STATE:  //0x22  generates RS-232/V.24 style control signals
                break;
              case SET_LINE_CODING:      //0x20  Configure
                break;
              default:
                len = 0xFF;                    /*֧*/
                break;
            }
          } else {
            //׼
            switch (SetupReq) {                                     //
              case USB_GET_DESCRIPTOR:
                switch (pSetupReqPak->wValue >> 8) {
                  case 1:                                             //豸
                    pDescr = DevDesc;                               //豸͵Ҫ͵Ļ
                    len = sizeof(DevDesc);
                    break;
                  case 2:                                             //
                    pDescr = CfgDesc;                               //豸͵Ҫ͵Ļ
                    len = sizeof(CfgDesc);
                    break;
                  case 3:
                    if ((pSetupReqPak->wValue & 0XFF) == 0) {
                      pDescr = LangDes;
                      len = sizeof(LangDes);
                    } else if ((pSetupReqPak->wValue & 0XFF) == 1) {
                      pDescr = Manuf_Des;
                      len = sizeof(Manuf_Des);
                    } else if ((pSetupReqPak->wValue & 0XFF) == 2) {
                      pDescr = Prod_Des;
                      len = sizeof(Prod_Des);
                    } else {
                      pDescr = SerDes;
                      len = sizeof(SerDes);
                    }
                    break;
                  case 0x22:                                          //

                    if ((pSetupReqPak->wValue & 0XFF) == 0) {           //ӿ1  HID豸
                      pDescr = HIDRepDesc;                        //׼ϴ
                      len = sizeof(HIDRepDesc);
                    } else {
                      len = 0xff;
                    }
                    break;
                  default:
                    len = 0xff;                                     //ֵ֧߳
                    break;
                }
                if (SetupLen > len) {
                  SetupLen = len;    //ܳ
                }
                len = SetupLen >= THIS_ENDP0_SIZE ? THIS_ENDP0_SIZE : SetupLen; //δ䳤
                memcpy(pEP0_DataBuf, pDescr, len);                      //ϴ
                SetupLen -= len;
                pDescr += len;
                break;
              case USB_SET_ADDRESS:
                SetupLen = (pSetupReqPak->wValue & 0XFF) ;                     //ݴUSB豸ַ
                break;
              case USB_GET_CONFIGURATION:
                pEP0_DataBuf[0] = UsbConfig;
                if (SetupLen >= 1) {
                  len = 1;
                }
                break;
              case USB_SET_CONFIGURATION:
                UsbConfig = (pSetupReqPak->wValue & 0XFF) ;
                if (UsbConfig) {
                  #ifdef DE_PRINTF
                  //printf("SET CONFIG.\n");
                  #endif
                  UsbConfigRdy = 1;                                      //set configһusböɵı־
                }
                break;
              case 0x0A:
                break;
              case USB_CLEAR_FEATURE:                                            //Clear Feature
                if ((pSetupReqPak->bRequestType & USB_REQ_RECIP_MASK) == USB_REQ_RECIP_ENDP) {  // ˵
                  switch ((pSetupReqPak->wValue & 0XFF) ) {
                    case 0x84:
                      R8_UEP4_CTRL = R8_UEP4_CTRL & ~(RB_UEP_T_TOG | MASK_UEP_T_RES) | UEP_T_RES_NAK;
                      break;
                    case 0x81:
                      R8_UEP1_CTRL = R8_UEP1_CTRL & ~(RB_UEP_T_TOG | MASK_UEP_T_RES) | UEP_T_RES_NAK;
                      break;
                    case 0x01:
                      R8_UEP1_CTRL = R8_UEP1_CTRL & ~(RB_UEP_R_TOG | MASK_UEP_R_RES) | UEP_R_RES_ACK;
                      break;
                    case 0x82:
                      R8_UEP2_CTRL = R8_UEP2_CTRL & ~(RB_UEP_T_TOG | MASK_UEP_T_RES) | UEP_T_RES_NAK;
                      break;
                    case 0x02:
                      R8_UEP2_CTRL = R8_UEP2_CTRL & ~(RB_UEP_R_TOG | MASK_UEP_R_RES) | UEP_R_RES_ACK;
                      break;
                    case 0x83:
                      R8_UEP3_CTRL = R8_UEP3_CTRL & ~(RB_UEP_T_TOG | MASK_UEP_T_RES) | UEP_T_RES_NAK;
                      break;
                    case 0x03:
                      R8_UEP3_CTRL = R8_UEP3_CTRL & ~(RB_UEP_R_TOG | MASK_UEP_R_RES) | UEP_R_RES_ACK;
                      break;
                    default:
                      len = 0xFF;                                            // ֵ֧Ķ˵
                      break;
                  }
                }
                if ((pSetupReqPak->bRequestType & USB_REQ_RECIP_MASK) == USB_REQ_RECIP_DEVICE) {  // 豸
                  break;
                } else {
                  len = 0xFF;                                                // Ƕ˵㲻֧
                }
                break;
              case USB_SET_FEATURE:                                              /* Set Feature */
                if ((pSetupReqPak->bRequestType & 0x1F) == 0x00) {              /* 豸 */
                  if (pSetupReqPak->wValue == 0x01) {
                    if (CfgDesc[ 7 ] & 0x20) {
                      /* ûʹܱ־ */
                    } else {
                      len = 0xFF;                                        /* ʧ */
                    }
                  } else {
                    len = 0xFF;                                            /* ʧ */
                  }
                } else if ((pSetupReqPak->bRequestType & 0x1F) == 0x02) {       /* ö˵ */
                  if (pSetupReqPak->wValue == 0x00) {
                    switch (pSetupReqPak->wIndex) {
                      case 0x84:
                        R8_UEP4_CTRL = R8_UEP4_CTRL & (~RB_UEP_T_TOG) | UEP_T_RES_STALL;/* ö˵4 IN STALL */
                        break;
                      case 0x01:
                        R8_UEP1_CTRL = R8_UEP1_CTRL & (~RB_UEP_R_TOG) | UEP_R_RES_STALL;/* ö˵1 OUT Stall */
                        break;
                      case 0x81:
                        R8_UEP1_CTRL = R8_UEP1_CTRL & (~RB_UEP_T_TOG) | UEP_T_RES_STALL;/* ö˵1 IN STALL */
                        break;
                      case 0x02:
                        R8_UEP2_CTRL = R8_UEP2_CTRL & (~RB_UEP_R_TOG) | UEP_R_RES_STALL;/* ö˵2 OUT Stall */
                        break;
                      case 0x82:
                        R8_UEP2_CTRL = R8_UEP2_CTRL & (~RB_UEP_T_TOG) | UEP_T_RES_STALL;/* ö˵2 IN STALL */
                        break;
                      case 0x03:
                        R8_UEP3_CTRL = R8_UEP3_CTRL & (~RB_UEP_R_TOG) | UEP_R_RES_STALL;/* ö˵3 OUT Stall */
                        break;
                      case 0x83:
                        R8_UEP3_CTRL = R8_UEP3_CTRL & (~RB_UEP_T_TOG) | UEP_T_RES_STALL;/* ö˵3 IN STALL */
                        break;

                      default:
                        len = 0xFF;                               //ʧ
                        break;
                    }
                  } else {
                    len = 0xFF;                                   //ʧ
                  }
                } else {
                  len = 0xFF;                                      //ʧ
                }
                break;
              case USB_GET_STATUS:
                pEP0_DataBuf[0] = 0x00;
                pEP0_DataBuf[1] = 0x00;
                if (SetupLen >= 2) {
                  len = 2;
                } else {
                  len = SetupLen;
                }
                break;
              default:
                len = 0xff;                                           //ʧ
                break;
            }
          }
        } else {
          len = 0xff;                                                   //ȴ
        }
        if (len == 0xff) {
          SetupReq = 0xFF;
          R8_UEP0_CTRL = RB_UEP_R_TOG | RB_UEP_T_TOG | UEP_R_RES_STALL | UEP_T_RES_STALL;//STALL
        } else if (len) {                                           //ϴݻ״̬׶η0Ȱ
          R8_UEP0_T_LEN = len;
          R8_UEP0_CTRL = RB_UEP_R_TOG | RB_UEP_T_TOG | UEP_R_RES_ACK | UEP_T_RES_ACK;//ĬݰDATA1ӦACK
        } else {
          R8_UEP0_T_LEN = 0;  //Ȼδ״̬׶ΣǰԤϴ0ݰԷǰ״̬׶
          R8_UEP0_CTRL = RB_UEP_R_TOG | RB_UEP_T_TOG | UEP_R_RES_ACK | UEP_T_RES_ACK;//ĬݰDATA1,ӦACK
        }
        break;
      case UIS_TOKEN_IN | 0:                                               //endpoint0 IN
        switch (SetupReq) {
          case USB_GET_DESCRIPTOR:
            len = SetupLen >= THIS_ENDP0_SIZE ? THIS_ENDP0_SIZE : SetupLen;    //δ䳤
            memcpy(pEP0_DataBuf, pDescr, len);                              //ϴ
            SetupLen -= len;
            pDescr += len;
            R8_UEP0_T_LEN = len;
            R8_UEP0_CTRL ^= RB_UEP_T_TOG;                                     //ͬ־λת
            break;
          case USB_SET_ADDRESS:
            R8_USB_DEV_AD = R8_USB_DEV_AD & RB_UDA_GP_BIT | SetupLen;
            R8_UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;
            break;
          default:
            R8_UEP0_T_LEN = 0;                                              //״̬׶жϻǿϴ0ݰƴ
            R8_UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;
            break;
        }
        break;
      case UIS_TOKEN_OUT | 0:  // endpoint0 OUT
        if (SetupReq == SET_LINE_CODING) { //ô
          if (RB_U_TOG_OK) {
            R8_UEP0_T_LEN = 0;
            R8_UEP0_CTRL |= UEP_R_RES_ACK | UEP_T_RES_ACK;  // ׼ϴ0
          }
        } else {
          R8_UEP0_T_LEN = 0;
          R8_UEP0_CTRL |= UEP_R_RES_ACK | UEP_T_RES_NAK;  //״̬׶ΣINӦNAK
        }
        R8_UEP0_CTRL ^= RB_UEP_R_TOG;                                     //ͬ־λת
        break;
      default:
        break;
    }
    R8_USB_INT_FG = RB_UIF_TRANSFER;                                                  //д0ж
  } else if (intflag & RB_UIF_BUS_RST) {                                                    //豸ģʽUSB߸λж
    R8_UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;
    R8_UEP1_CTRL = RB_UEP_AUTO_TOG | UEP_R_RES_ACK;
    R8_UEP2_CTRL = RB_UEP_AUTO_TOG | UEP_R_RES_ACK | UEP_T_RES_NAK;
    R8_USB_DEV_AD = 0x00;
    R8_USB_INT_FG |= RB_UIF_BUS_RST;                                                //жϱ־
  }else if (intflag & RB_UIF_SUSPEND) {                                                   //USB߹/
    R8_USB_INT_FG = RB_UIF_SUSPEND;
    if (R8_USB_MIS_ST & RB_UMS_SUSPEND) {                                 //
      #ifdef DEBUG
      //printf( "zz" );                                              //˯״̬
      #endif
    }
  } else {                                                             //ж,ܷ
    R8_USB_INT_FG = intflag;                                               //жϱ־
    //      printf("UnknownInt  N");
  }
}

